<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    version="3.0" exclude-result-prefixes="xs">
    
    <xsl:template name="main">
        <xsl:for-each select="document('../contents.xml')/contents/section">
            <xsl:variable name="jsFunc" select="concat('function test() {location.replace(../index.html#!',@name,')')" />

            <xsl:apply-templates select="page" >
                <xsl:with-param name="levelName" select="@name" as="xs:string"/>
            </xsl:apply-templates>
        </xsl:for-each>
    </xsl:template>
    <xsl:template match="page|subpage">
        <xsl:param name="levelName" select="''" as="xs:string"/>
        <xsl:variable name="fileName" select="concat($levelName,'/',@name,'.xml')" as="xs:string" />
        <xsl:variable name="pageName" select="if(@name='intro') then '' else concat('/',@anme)" />
        <xsl:message select="$fileName"></xsl:message>
        
        <xsl:variable name="jsFunc2" select="concat('function test() {location.replace(&quot;../index.html#!',$levelName,$pageName,'&quot;)}')"/>
        <xsl:result-document method="html" href="{$fileName}">
            
            <html>
                <head><title>Saxonica:XSLT and XQuery Processor</title>
                    
                    <xsl:element name="script">
                        <xsl:attribute name="type">text/javascript</xsl:attribute>
                        <xsl:value-of select="$jsFunc2" />
                    </xsl:element>
                    
                </head>
                <body>
                    
                    <script type="text/javascript">
                        test();  
                    </script>
                    <noscript>
                        <p>The Saxonica site is best viewed with Javascript enabled. If you are unable to turn on Javascript, please use this 
                            <xsl:element name="a">
                                <xsl:attribute name="href"><xsl:value-of select="concat('../',$levelName)" /></xsl:attribute>
                                page
                            </xsl:element>
                        </p>
                    </noscript>
                    
                </body>
            </html>
            
        </xsl:result-document>
            
        <xsl:for-each select=".">

            <xsl:apply-templates>
                <xsl:with-param name="levelName" select="concat($levelName,'/', @name)"></xsl:with-param>
            </xsl:apply-templates>
                
            </xsl:for-each>
        
        
    </xsl:template>
    
</xsl:stylesheet>